(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
	typeof define === 'function' && define.amd ? define('angularx-flatpickr', ['exports', '@angular/core', '@angular/forms'], factory) :
	(factory((global['angularx-flatpickr'] = {}),global.ng.core,global.ng.forms));
}(this, (function (exports,core,forms) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */










function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

var FlatpickrDefaults = /** @class */ (function () {
    function FlatpickrDefaults() {
        this.altFormat = 'F j, Y';
        this.altInput = false;
        this.altInputClass = '';
        this.allowInput = false;
        this.appendTo = undefined;
        this.clickOpens = true;
        this.dateFormat = 'Y-m-d';
        this.disable = [];
        this.disableMobile = false;
        this.enable = [];
        this.enableTime = false;
        this.enableSeconds = false;
        this.hourIncrement = 1;
        this.inline = false;
        this.maxDate = undefined;
        this.minDate = undefined;
        this.minuteIncrement = 5;
        this.mode = 'single';
        this.nextArrow = '>';
        this.noCalendar = false;
        this.prevArrow = '<';
        this.shorthandCurrentMonth = false;
        this.static = false;
        this.time24hr = false;
        this.utc = false;
        this.weekNumbers = false;
        this.wrap = false;
        this.plugins = [];
        this.convertModelValue = false;
    }
    return FlatpickrDefaults;
}());
FlatpickrDefaults.decorators = [
    { type: core.Injectable },
];
var FLATPICKR = new core.InjectionToken('flatpickr');
var FLATPICKR_CONTROL_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return FlatpickrDirective; }),
    multi: true
};
var FlatpickrDirective = /** @class */ (function () {
    function FlatpickrDirective(elm, defaults, renderer, flatpickrFactory) {
        this.elm = elm;
        this.defaults = defaults;
        this.renderer = renderer;
        this.flatpickrFactory = flatpickrFactory;
        this.flatpickrReady = new core.EventEmitter();
        this.flatpickrChange = new core.EventEmitter();
        this.flatpickrValueUpdate = new core.EventEmitter();
        this.flatpickrOpen = new core.EventEmitter();
        this.flatpickrClose = new core.EventEmitter();
        this.flatpickrMonthChange = new core.EventEmitter();
        this.flatpickrYearChange = new core.EventEmitter();
        this.flatpickrDayCreate = new core.EventEmitter();
        this.isDisabled = false;
        this.onChangeFn = function () { };
        this.onTouchedFn = function () { };
    }
    FlatpickrDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        var options = {
            altFormat: this.altFormat,
            altInput: this.altInput,
            altInputClass: this.altInputClass,
            allowInput: this.allowInput,
            appendTo: this.appendTo,
            clickOpens: this.clickOpens,
            dateFormat: this.dateFormat,
            disable: this.disable,
            disableMobile: this.disableMobile,
            enable: this.enable,
            enableTime: this.enableTime,
            enableSeconds: this.enableSeconds,
            hourIncrement: this.hourIncrement,
            defaultDate: this.initialValue,
            inline: this.inline,
            maxDate: this.maxDate,
            minDate: this.minDate,
            minuteIncrement: this.minuteIncrement,
            mode: this.mode,
            nextArrow: this.nextArrow,
            noCalendar: this.noCalendar,
            parseDate: this.parseDate,
            prevArrow: this.prevArrow,
            shorthandCurrentMonth: this.shorthandCurrentMonth,
            static: this.static,
            time24hr: this.time24hr,
            weekNumbers: this.weekNumbers,
            getWeek: this.getWeek,
            wrap: this.wrap,
            plugins: this.plugins,
            onChange: function (selectedDates, dateString, instance) {
                _this.flatpickrChange.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onOpen: function (selectedDates, dateString, instance) {
                _this.flatpickrOpen.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onClose: function (selectedDates, dateString, instance) {
                _this.flatpickrClose.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onMonthChange: function (selectedDates, dateString, instance) {
                _this.flatpickrMonthChange.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onYearChange: function (selectedDates, dateString, instance) {
                _this.flatpickrYearChange.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onReady: function (selectedDates, dateString, instance) {
                _this.flatpickrReady.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onValueUpdate: function (selectedDates, dateString, instance) {
                _this.flatpickrValueUpdate.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onDayCreate: function (selectedDates, dateString, instance, dayElement) {
                _this.flatpickrDayCreate.emit({
                    selectedDates: selectedDates,
                    dateString: dateString,
                    instance: instance,
                    dayElement: dayElement
                });
            }
        };
        if (this.locale) {
            options.locale = this.locale;
        }
        Object.keys(options).forEach(function (key) {
            if (typeof options[key] === 'undefined') {
                options[key] = ((_this)).defaults[key];
            }
        });
        options.time_24hr = options.time24hr;
        this.instance = this.flatpickrFactory(this.elm.nativeElement, options);
        this.setDisabledState(this.isDisabled);
    };
    FlatpickrDirective.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (this.instance) {
            Object.keys(changes).forEach(function (inputKey) {
                _this.instance.set((inputKey), ((_this))[inputKey]);
            });
        }
    };
    FlatpickrDirective.prototype.ngOnDestroy = function () {
        this.instance.destroy();
    };
    FlatpickrDirective.prototype.writeValue = function (value) {
        var convertedValue = value;
        if (this.convertModelValue && this.mode === 'range' && value) {
            convertedValue = [value.from, value.to];
        }
        if (this.instance) {
            this.instance.setDate(convertedValue);
        }
        else {
            this.initialValue = convertedValue;
        }
    };
    FlatpickrDirective.prototype.registerOnChange = function (fn) {
        this.onChangeFn = fn;
    };
    FlatpickrDirective.prototype.registerOnTouched = function (fn) {
        this.onTouchedFn = fn;
    };
    FlatpickrDirective.prototype.setDisabledState = function (isDisabled) {
        this.isDisabled = isDisabled;
        if (this.instance) {
            if (this.isDisabled) {
                this.renderer.setProperty(this.instance._input, 'disabled', 'disabled');
            }
            else {
                this.renderer.removeAttribute(this.instance._input, 'disabled');
            }
        }
    };
    FlatpickrDirective.prototype.inputChanged = function () {
        var _this = this;
        var value = this.elm.nativeElement.value;
        if (this.convertModelValue && typeof value === 'string') {
            switch (this.mode) {
                case 'multiple':
                    var dates = value
                        .split('; ')
                        .map(function (str) { return _this.instance.parseDate(str, _this.instance.config.dateFormat, !_this.instance.config.enableTime); });
                    this.onChangeFn(dates);
                    break;
                case 'range':
                    var _a = __read(value
                        .split(this.instance.l10n.rangeSeparator)
                        .map(function (str) { return _this.instance.parseDate(str, _this.instance.config.dateFormat, !_this.instance.config.enableTime); }), 2), from = _a[0], to = _a[1];
                    this.onChangeFn({ from: from, to: to });
                    break;
                case 'single':
                default:
                    this.onChangeFn(this.instance.parseDate(value, this.instance.config.dateFormat, !this.instance.config.enableTime));
            }
        }
        else {
            this.onChangeFn(value);
        }
    };
    return FlatpickrDirective;
}());
FlatpickrDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[mwlFlatpickr]',
                providers: [FLATPICKR_CONTROL_VALUE_ACCESSOR],
                host: {
                    '(blur)': 'onTouchedFn()'
                }
            },] },
];
FlatpickrDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: FlatpickrDefaults, },
    { type: core.Renderer2, },
    { type: undefined, decorators: [{ type: core.Inject, args: [FLATPICKR,] },] },
]; };
FlatpickrDirective.propDecorators = {
    "altFormat": [{ type: core.Input },],
    "altInput": [{ type: core.Input },],
    "altInputClass": [{ type: core.Input },],
    "allowInput": [{ type: core.Input },],
    "appendTo": [{ type: core.Input },],
    "clickOpens": [{ type: core.Input },],
    "dateFormat": [{ type: core.Input },],
    "disable": [{ type: core.Input },],
    "disableMobile": [{ type: core.Input },],
    "enable": [{ type: core.Input },],
    "enableTime": [{ type: core.Input },],
    "enableSeconds": [{ type: core.Input },],
    "hourIncrement": [{ type: core.Input },],
    "inline": [{ type: core.Input },],
    "maxDate": [{ type: core.Input },],
    "minDate": [{ type: core.Input },],
    "minuteIncrement": [{ type: core.Input },],
    "mode": [{ type: core.Input },],
    "nextArrow": [{ type: core.Input },],
    "noCalendar": [{ type: core.Input },],
    "parseDate": [{ type: core.Input },],
    "prevArrow": [{ type: core.Input },],
    "shorthandCurrentMonth": [{ type: core.Input },],
    "static": [{ type: core.Input },],
    "time24hr": [{ type: core.Input },],
    "weekNumbers": [{ type: core.Input },],
    "getWeek": [{ type: core.Input },],
    "wrap": [{ type: core.Input },],
    "plugins": [{ type: core.Input },],
    "locale": [{ type: core.Input },],
    "convertModelValue": [{ type: core.Input },],
    "flatpickrReady": [{ type: core.Output },],
    "flatpickrChange": [{ type: core.Output },],
    "flatpickrValueUpdate": [{ type: core.Output },],
    "flatpickrOpen": [{ type: core.Output },],
    "flatpickrClose": [{ type: core.Output },],
    "flatpickrMonthChange": [{ type: core.Output },],
    "flatpickrYearChange": [{ type: core.Output },],
    "flatpickrDayCreate": [{ type: core.Output },],
    "inputChanged": [{ type: core.HostListener, args: ['input',] },],
};
var USER_DEFAULTS = new core.InjectionToken('flatpickr defaults');
function defaultsFactory(userDefaults) {
    var defaults = new FlatpickrDefaults();
    Object.assign(defaults, userDefaults);
    return defaults;
}
var FlatpickrModule = /** @class */ (function () {
    function FlatpickrModule() {
    }
    FlatpickrModule.forRoot = function (flatpickr, userDefaults) {
        if (userDefaults === void 0) { userDefaults = {}; }
        return {
            ngModule: FlatpickrModule,
            providers: [
                flatpickr,
                {
                    provide: USER_DEFAULTS,
                    useValue: userDefaults
                },
                {
                    provide: FlatpickrDefaults,
                    useFactory: defaultsFactory,
                    deps: [USER_DEFAULTS]
                }
            ]
        };
    };
    return FlatpickrModule;
}());
FlatpickrModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [FlatpickrDirective],
                exports: [FlatpickrDirective]
            },] },
];

exports.FlatpickrDefaults = FlatpickrDefaults;
exports.USER_DEFAULTS = USER_DEFAULTS;
exports.defaultsFactory = defaultsFactory;
exports.FlatpickrModule = FlatpickrModule;
exports.FLATPICKR = FLATPICKR;
exports.ɵa = FLATPICKR_CONTROL_VALUE_ACCESSOR;
exports.ɵb = FlatpickrDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angularx-flatpickr.umd.js.map
